package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.PersistenceUtil;

public class LoadStateWithFind {
    static EntityManagerFactory entityManagerFactory =
            Persistence.createEntityManagerFactory("example-unit");
    public static void main(String[] args) {
        try {
            persistEmployee();
            findEmployee();
        } finally {
            entityManagerFactory.close();
        }
    }

    static void findEmployee() {
        EntityManager em = entityManagerFactory.createEntityManager();
        Employee employee = em.find(Employee.class, 1);
        printLoadState("After find()", employee);
        //accessing phones via Phone.toString()
        System.out.println("Accessing phones: " + employee.getPhones());
        printLoadState("After accessing phones", employee);
        em.close();
    }

    static void persistEmployee() {
        Employee employee = new Employee("Joe", "IT",
                Phone.cell("111-111-1111"), Phone.work("222-222-2222"));
        EntityManager em = entityManagerFactory.createEntityManager();
        em.getTransaction().begin();
        em.persist(employee);
        em.getTransaction().commit();
        em.close();
    }

    static void printLoadState(String msg, Employee employee) {
        System.out.printf("-- %s --%n", msg);
        PersistenceUtil pu = Persistence.getPersistenceUtil();
        boolean employeeLoaded = pu.isLoaded(employee);
        System.out.printf("employee loaded: %s%n", employeeLoaded);
        boolean phonesLoaded = pu.isLoaded(employee, "phones");
        System.out.printf("  phones loaded: %s%n", phonesLoaded);
        System.out.println("---------------");
    }
}