package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import java.util.List;
import static com.logicbig.example.LoadStateWithFind.persistEmployee;
import static com.logicbig.example.LoadStateWithFind.printLoadState;

public class LoadStateWithJPQLSelect {
    static EntityManagerFactory entityManagerFactory =
            Persistence.createEntityManagerFactory("example-unit");

    public static void main(String[] args) {
        try {
            persistEmployee();
            findEmployeeByJPQL();
        } finally {
            entityManagerFactory.close();
        }
    }

    static void findEmployeeByJPQL() {
        EntityManager em = entityManagerFactory.createEntityManager();
        List<Employee> employees = em.createQuery("Select t from Employee t")
                                     .getResultList();
        Employee employee = employees.get(0);
        printLoadState("After JPQL Select", employee);
        //accessing phones via Phone.toString()
        System.out.println("Accessing phones: " + employee.getPhones());
        printLoadState("After accessing phones", employee);
        em.close();
    }
}